diff --git openjdk-orig/hotspot/src/os_cpu/linux_x86/vm/os_linux_x86.cpp openjdk/hotspot/src/os_cpu/linux_x86/vm/os_linux_x86.cpp
index 174c1df..33d09bf 100644
--- openjdk-orig/hotspot/src/os_cpu/linux_x86/vm/os_linux_x86.cpp
+++ openjdk/hotspot/src/os_cpu/linux_x86/vm/os_linux_x86.cpp
@@ -47,6 +47,11 @@
 # include <ucontext.h>
 # include <fpu_control.h>
 
+// Registers are not specified in LSB's ucontext and are unlikely to be in LSB
+#include <lsb_flags.h>
+// For pthread_getattr_np
+#include <lsb_wrappers.h>
+
 #ifdef AMD64
 #define REG_SP REG_RSP
 #define REG_PC REG_RIP
diff --git openjdk-orig/hotspot/src/share/vm/libadt/dict.cpp openjdk/hotspot/src/share/vm/libadt/dict.cpp
index 3ac20d6..dbc9519 100644
--- openjdk-orig/hotspot/src/share/vm/libadt/dict.cpp
+++ openjdk/hotspot/src/share/vm/libadt/dict.cpp
@@ -33,7 +33,8 @@
 //IMPLEMENTATION
 // #include "dict.hpp"
 
-#include <assert.h>
+// not used
+//#include <assert.h>
 
 // The iostream is not needed and it gets confused for gcc by the
 // define of bool.
diff --git openjdk-orig/hotspot/src/share/vm/utilities/globalDefinitions_gcc.hpp openjdk/hotspot/src/share/vm/utilities/globalDefinitions_gcc.hpp
index 417978f..2f3f072 100644
--- openjdk-orig/hotspot/src/share/vm/utilities/globalDefinitions_gcc.hpp
+++ openjdk/hotspot/src/share/vm/utilities/globalDefinitions_gcc.hpp
@@ -227,7 +227,7 @@ inline int g_isnan(float  f) { return isnand(f); }
 #endif
 inline int g_isnan(double f) { return isnand(f); }
 #elif LINUX
-inline int g_isnan(float  f) { return isnanf(f); }
+inline int g_isnan(float  f) { return isnan(f); }
 inline int g_isnan(double f) { return isnan(f); }
 #else
 #error "missing platform-specific definition here"
@@ -235,8 +235,8 @@ inline int g_isnan(double f) { return isnan(f); }
 
 // Checking for finiteness
 
-inline int g_isfinite(jfloat  f)                 { return finite(f); }
-inline int g_isfinite(jdouble f)                 { return finite(f); }
+inline int g_isfinite(jfloat  f)                 { return isfinite(f); }
+inline int g_isfinite(jdouble f)                 { return isfinite(f); }
 
 
 // Wide characters
diff --git openjdk-orig/jdk/make/Makefile openjdk/jdk/make/Makefile
index 323bfcb..5ea9453 100644
--- openjdk-orig/jdk/make/Makefile
+++ openjdk/jdk/make/Makefile
@@ -346,6 +346,12 @@ include $(BUILDDIR)/common/internal/BinaryPlugs.gmk
 #
 include $(BUILDDIR)/common/Rules-SCCS.gmk
 
+# LSB rules
+ifdef OPENJDK_LSB_VERSION
+# Add lsb helper's build right after tools build, which is required for it
+SUBDIRS := $(subst tools,tools lsb,$(SUBDIRS))
+endif
+
 # JPRT rules
 include jprt.gmk
 
diff --git openjdk-orig/jdk/make/common/Defs-linux.gmk openjdk/jdk/make/common/Defs-linux.gmk
index 34f89d6..1339e13 100644
--- openjdk-orig/jdk/make/common/Defs-linux.gmk
+++ openjdk/jdk/make/common/Defs-linux.gmk
@@ -362,3 +362,6 @@ else
   INCLUDE_SA = true
 endif
 
+# LSB piece of stuff
+include $(BUILDDIR)/lsb/Defs-lsb.gmk
+
diff --git openjdk-orig/jdk/make/common/Defs.gmk openjdk/jdk/make/common/Defs.gmk
index c56440d..a6f3f74 100644
--- openjdk-orig/jdk/make/common/Defs.gmk
+++ openjdk/jdk/make/common/Defs.gmk
@@ -247,6 +247,12 @@ DEVTOOLS_FT_DIR_EXISTS = $(shell \
       FREETYPE_HEADERS_PATH = /usr/include
     endif
   endif
+
+  # For openjdk we have other plans on freetype
+  # Some stuff needs to be inlined
+  ifdef OPENJDK_LSB_VERSION
+    FREETYPE_LIB += -llsb_helper_openjdk7
+  endif
 endif
 
 #
diff --git openjdk-orig/jdk/make/common/shared/Compiler-gcc.gmk openjdk/jdk/make/common/shared/Compiler-gcc.gmk
index 9b3b668..4c20c5e 100644
--- openjdk-orig/jdk/make/common/shared/Compiler-gcc.gmk
+++ openjdk/jdk/make/common/shared/Compiler-gcc.gmk
@@ -157,3 +157,11 @@ endif
 _CC_VER :=$(shell $(CC) -dumpversion 2>&1 )
 CC_VER  :=$(call GetVersion,"$(_CC_VER)")
 
+ifdef OPENJDK_LSB_VERSION
+    CC = /opt/lsb/bin/lsbcc $(LSB_INCLUDE_AUX)
+    CPP = /opt/lsb/bin/lsbcc -E $(LSB_INCLUDE_AUX)
+    STATIC_CXX = false
+    CXX = /opt/lsb/bin/lsbc++ $(LSB_INCLUDE_AUX)
+    COMPILER_NAME = LSBCC_$(OPENJDK_LSB_VERSION)
+endif
+
diff --git openjdk-orig/jdk/make/common/shared/Sanity.gmk openjdk/jdk/make/common/shared/Sanity.gmk
index 3bf91dc..e049615 100644
--- openjdk-orig/jdk/make/common/shared/Sanity.gmk
+++ openjdk/jdk/make/common/shared/Sanity.gmk
@@ -788,6 +788,7 @@ sane-motif:
 
 ifdef OPENJDK
 
+ifndef OPENJDK_LSB_VERSION
 #name of test program that prints out "Failed" if freetype is not good enough
 FREETYPE_VERSION_CHECK_NAME = freetype_versioncheck
 FREETYPE_VERSION_CHECK = $(TEMPDIR)/$(FREETYPE_VERSION_CHECK_NAME)$(EXE_SUFFIX)
@@ -805,6 +806,8 @@ sane-freetype:
 	          "or higher is required. \n" >> $(ERROR_FILE) ; \
 	fi
 
+endif
+
 else
 #do nothing  (not OpenJDK)
 sane-freetype: 
diff --git openjdk-orig/jdk/make/java/management/Makefile openjdk/jdk/make/java/management/Makefile
index 8e905a1..22612b8 100644
--- openjdk-orig/jdk/make/java/management/Makefile
+++ openjdk/jdk/make/java/management/Makefile
@@ -107,3 +107,8 @@ clean clobber::
 	$(RM) -r $(CLASSDESTDIR)/sun/management
 	$(RM) $(TEMPDIR)/manifest $(AGENTJAR)
 
+# This library uses(used) non-lsb interfaces
+ifdef OPENJDK_LSB_VERSION
+OTHER_LDLIBS += -llsb_helper_openjdk7
+endif
+
diff --git openjdk-orig/jdk/make/java/nio/Makefile openjdk/jdk/make/java/nio/Makefile
index 93a7593..32f9517 100644
--- openjdk-orig/jdk/make/java/nio/Makefile
+++ openjdk/jdk/make/java/nio/Makefile
@@ -140,6 +140,9 @@ endif
 ifeq ($(PLATFORM), linux)
 COMPILER_WARNINGS_FATAL=true
 OTHER_LDLIBS += -L$(LIBDIR)/$(LIBARCH) -ljava -lnet -lpthread -ldl
+ifdef OPENJDK_LSB_VERSION
+OTHER_LDLIBS += -llsb_helper_openjdk7
+endif
 endif
 ifeq ($(PLATFORM), solaris)
 OTHER_LDLIBS += $(JVMLIB) $(LIBSOCKET) -lposix4 -ldl \
diff --git openjdk-orig/jdk/make/javax/sound/jsoundalsa/Makefile openjdk/jdk/make/javax/sound/jsoundalsa/Makefile
index e4e83a3..2f86c61 100644
--- openjdk-orig/jdk/make/javax/sound/jsoundalsa/Makefile
+++ openjdk/jdk/make/javax/sound/jsoundalsa/Makefile
@@ -87,5 +87,9 @@ vpath %.cpp $(PLATFORM_SRC)/native/com/sun/media/sound
 #
 include $(BUILDDIR)/common/Library.gmk
 
+ifdef OPENJDK_LSB_VERSION
+OTHER_LDLIBS += -llsb_helper_openjdk7
+endif
+
 
 
diff --git openjdk-orig/jdk/make/lsb/Defs-lsb.gmk openjdk/jdk/make/lsb/Defs-lsb.gmk
new file mode 100644
index 0000000..f2a603c
--- /dev/null
+++ openjdk/jdk/make/lsb/Defs-lsb.gmk
@@ -0,0 +1,20 @@
+# Some definitions for LSB build
+# included in Defs-linux.gmk
+
+ifdef OPENJDK_LSB_VERSION
+# define some dirs
+LSBSRCDIR = $(PLATFORM_SRC)/../linux/lsb
+LSB_INCLUDE_AUX = -isystem $(LSBSRCDIR)/include -I$(LSBSRCDIR)
+LIBLSB = liblsb_helper_jdk7.a
+
+# No static libgcc.  We're stable!
+OTHER_LDFLAGS := $(filter-out -static-libgcc,$(OTHER_LDFLAGS))
+
+# For openjdk we had to inline some interfaces of freetype
+# Appending the proper libs here
+#FREETYPE_LIB += -llsb_helper_openjdk7
+override FREETYPE_HEADERS_PATH = 
+
+endif
+
+
diff --git openjdk-orig/jdk/make/tools/freetypecheck/Makefile openjdk/jdk/make/tools/freetypecheck/Makefile
index 560169e..76eb3b7 100644
--- openjdk-orig/jdk/make/tools/freetypecheck/Makefile
+++ openjdk/jdk/make/tools/freetypecheck/Makefile
@@ -23,7 +23,6 @@
 # have any questions.
 
 # Builds test program for freetype sanity check.
-#
 # Makefile should be called with following input parameters
 #   FT_TEST    - full name of test program
 #   FT_HEADERS - path to freetype headers
@@ -74,3 +73,4 @@ $(FT_TEST_PATH): freetypecheck.c
 ifeq ($(PLATFORM), windows)
 	@$(CP) $(FREETYPE_DLL) `dirname $@`
 endif
+
diff --git openjdk-orig/jdk/make/tools/freetypecheck/freetypecheck.c openjdk/jdk/make/tools/freetypecheck/freetypecheck.c
index 00f460d..eaba426 100644
--- openjdk-orig/jdk/make/tools/freetypecheck/freetypecheck.c
+++ openjdk/jdk/make/tools/freetypecheck/freetypecheck.c
@@ -33,6 +33,7 @@
 #define QUOTEME(x) #x
 
 int main(char** argv, int argc) {
+#ifndef __LSB_VERSION__
    char v[50];
    FT_Int major, minor, patch;
    FT_Library library;
@@ -54,6 +55,7 @@ int main(char** argv, int argc) {
    if (strcmp(v, QUOTEMACRO(REQUIRED_FREETYPE_VERSION)) < 0) {
       printf("Failed: too old library.\n");
    }
+#endif
 
    return 0;
 }
diff --git openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_ImageAffine.h openjdk/jdk/src/share/native/sun/awt/medialib/mlib_ImageAffine.h
index 927bae1..31cc6f3 100644
--- openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_ImageAffine.h
+++ openjdk/jdk/src/share/native/sun/awt/medialib/mlib_ImageAffine.h
@@ -27,6 +27,9 @@
 #ifndef __MLIB_IMAGEAFFINE_H
 #define __MLIB_IMAGEAFFINE_H
 
+// For NULL definition
+#include <stddef.h>
+
 #include "mlib_image.h"
 #include "mlib_ImageDivTables.h"
 #include "mlib_ImageFilters.h"
diff --git openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_image.h openjdk/jdk/src/share/native/sun/awt/medialib/mlib_image.h
index 922879a..be6c93b 100644
--- openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_image.h
+++ openjdk/jdk/src/share/native/sun/awt/medialib/mlib_image.h
@@ -27,6 +27,8 @@
 #ifndef MLIB_IMAGE_H
 #define MLIB_IMAGE_H
 
+#include <stddef.h>
+
 #include <mlib_types.h>
 #include <mlib_status.h>
 #include <mlib_sys.h>
diff --git openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_sys.c openjdk/jdk/src/share/native/sun/awt/medialib/mlib_sys.c
index e63cf42..27b68ee 100644
--- openjdk-orig/jdk/src/share/native/sun/awt/medialib/mlib_sys.c
+++ openjdk/jdk/src/share/native/sun/awt/medialib/mlib_sys.c
@@ -87,7 +87,11 @@ void *__mlib_malloc(mlib_u32 size)
    */
   return (void *) malloc(size);
 #else /* _MSC_VER */
-  return (void *) memalign(8, size);
+  void * ptr;
+  if (posix_memalign(&ptr, 8, size) != 0){
+      return NULL;
+  }
+  return ptr;
 #endif /* _MSC_VER */
 }
 
diff --git openjdk-orig/jdk/src/share/native/sun/font/freetypeScaler.c openjdk/jdk/src/share/native/sun/font/freetypeScaler.c
index 4398df2..091dd9e 100644
--- openjdk-orig/jdk/src/share/native/sun/font/freetypeScaler.c
+++ openjdk/jdk/src/share/native/sun/font/freetypeScaler.c
@@ -38,9 +38,13 @@
 #include FT_SIZES_H
 #include FT_OUTLINE_H
 #include FT_SYNTHESIS_H
+#include FT_SYSTEM_H
 
 #include "fontscaler.h"
 
+#include "lsb_wrappers.h"
+#include "lsb_flags.h"
+
 #define  ftFixed1  (FT_Fixed) (1 << 16)
 #define  FloatToFTFixed(f) (FT_Fixed)((f) * (float)(ftFixed1))
 #define  FTFixedToFloat(x) ((x) / (float)(ftFixed1))
diff --git openjdk-orig/jdk/src/share/native/sun/java2d/opengl/OGLFuncs.h openjdk/jdk/src/share/native/sun/java2d/opengl/OGLFuncs.h
index 3d22a0c..3498dc5 100644
--- openjdk-orig/jdk/src/share/native/sun/java2d/opengl/OGLFuncs.h
+++ openjdk/jdk/src/share/native/sun/java2d/opengl/OGLFuncs.h
@@ -32,6 +32,7 @@
 #include "OGLFuncMacros.h"
 #include "OGLFuncs_md.h"
 #include "Trace.h"
+#include <dlfcn.h>
 
 jboolean OGLFuncs_OpenLibrary();
 void     OGLFuncs_CloseLibrary();
diff --git openjdk-orig/jdk/src/solaris/bin/java_md.c openjdk/jdk/src/solaris/bin/java_md.c
index 71c598f..5f7429c 100644
--- openjdk-orig/jdk/src/solaris/bin/java_md.c
+++ openjdk/jdk/src/solaris/bin/java_md.c
@@ -991,7 +991,11 @@ physical_memory(void) {
   const uint64_t pages     = (uint64_t) sysconf(_SC_PHYS_PAGES);
   const uint64_t page_size = (uint64_t) sysconf(_SC_PAGESIZE);
   const uint64_t result    = pages * page_size;
+#ifndef __LSB_VERSION__
 # define UINT64_FORMAT "%" PRIu64
+#else
+# define UINT64_FORMAT "%" "llu"
+#endif
 
   if (_launcher_debug) {
     printf("pages: " UINT64_FORMAT
diff --git openjdk-orig/jdk/src/solaris/hpi/native_threads/src/sys_api_td.c openjdk/jdk/src/solaris/hpi/native_threads/src/sys_api_td.c
index ab678d2..913fc5a 100644
--- openjdk-orig/jdk/src/solaris/hpi/native_threads/src/sys_api_td.c
+++ openjdk/jdk/src/solaris/hpi/native_threads/src/sys_api_td.c
@@ -544,12 +544,12 @@ sysBind(int fd, struct sockaddr *addr, int size)  {
 
 int
 sysAccept(int fd, struct sockaddr *him, int *len) {
-    INTERRUPT_IO(accept(fd, him, (uint *)len))
+    INTERRUPT_IO(accept(fd, him, (socklen_t *)len))
 }
 
 int
 sysGetSockName(int fd, struct sockaddr *him, int *len) {
-    return getsockname(fd, him, (uint *)len);
+    return getsockname(fd, him, (socklen_t *)len);
 }
 
 int
@@ -604,5 +604,5 @@ sysSendTo(int fd, char *buf, int len,
 SSIZE_T
 sysRecvFrom(int fd, char *buf, int nBytes,
             int flags, struct sockaddr *from, int *fromlen) {
-    INTERRUPT_IO(recvfrom(fd, buf, nBytes, flags, from, (uint *)fromlen))
+    INTERRUPT_IO(recvfrom(fd, buf, nBytes, flags, from, (socklen_t *)fromlen))
 }
diff --git openjdk-orig/jdk/src/solaris/hpi/native_threads/src/threads_linux.c openjdk/jdk/src/solaris/hpi/native_threads/src/threads_linux.c
index cf56780..50bcfbd 100644
--- openjdk-orig/jdk/src/solaris/hpi/native_threads/src/threads_linux.c
+++ openjdk/jdk/src/solaris/hpi/native_threads/src/threads_linux.c
@@ -58,7 +58,7 @@ static void prtsigset(char *s, sigset_t *set)
 {
     int sig;
     dprintf(2, "%s:", s);
-    for (sig = 1; sig < _NSIG; sig++) {
+    for (sig = 1; sig < NSIG; sig++) {
         if (sigismember(set, sig)) {
             dprintf(2, " %d", sig);
         }
diff --git openjdk-orig/jdk/src/solaris/hpi/src/memory_md.c openjdk/jdk/src/solaris/hpi/src/memory_md.c
index eeed396..2ab6c41 100644
--- openjdk-orig/jdk/src/solaris/hpi/src/memory_md.c
+++ openjdk/jdk/src/solaris/hpi/src/memory_md.c
@@ -394,7 +394,10 @@ sysDecommitMem(void *requestedAddr, size_t requestedSize,
 void *
 sysAllocBlock(size_t size, void** allocHead)
 {
-    void* alignedPtr = memalign(PAGE_ALIGNMENT, size);
+    void* alignedPtr;
+    if (posix_memalign(&alignedPtr, PAGE_ALIGNMENT, size) != 0){
+        return NULL;
+    }
     *allocHead = alignedPtr;
     return alignedPtr;
 }
diff --git openjdk-orig/jdk/src/solaris/native/com/sun/management/UnixOperatingSystem_md.c openjdk/jdk/src/solaris/native/com/sun/management/UnixOperatingSystem_md.c
index fff365e..2839d0b 100644
--- openjdk-orig/jdk/src/solaris/native/com/sun/management/UnixOperatingSystem_md.c
+++ openjdk/jdk/src/solaris/native/com/sun/management/UnixOperatingSystem_md.c
@@ -43,6 +43,8 @@
 #include <limits.h>
 #include <stdlib.h>
 #include <unistd.h>
+#include <string.h>
+#include <stdio.h>
 
 static jlong page_size = 0;
 
@@ -267,8 +269,13 @@ Java_com_sun_management_UnixOperatingSystem_getOpenFileDescriptorCount
 
     dirp = opendir("/proc/self/fd");
     if (dirp == NULL) {
-        throw_internal_error(env, "Unable to open directory /proc/self/fd");
-        return -1;
+        // We may be without /proc, so we should have a workaround
+        int i;
+        fds=0;
+        for (i=0; i<sysconf(_SC_OPEN_MAX); i++){
+            if (fcntl(i,F_GETFD)!=-1) fds++;
+        }
+        return fds;
     }
 
     // iterate through directory entries, skipping '.' and '..'
diff --git openjdk-orig/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiIn.c openjdk/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiIn.c
index be44713..354b012 100644
--- openjdk-orig/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiIn.c
+++ openjdk/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiIn.c
@@ -33,6 +33,8 @@
 #include "PlatformMidi.h"
 #include "PLATFORM_API_LinuxOS_ALSA_MidiUtils.h"
 
+#include <lsb_flags.h>
+
 /*
  * Helper methods
  */
diff --git openjdk-orig/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiUtils.h openjdk/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiUtils.h
index 3536cba..0185a5a 100644
--- openjdk-orig/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiUtils.h
+++ openjdk/jdk/src/solaris/native/com/sun/media/sound/PLATFORM_API_LinuxOS_ALSA_MidiUtils.h
@@ -24,6 +24,8 @@
  */
 
 #include <alsa/asoundlib.h>
+// For functions not in alsa
+#include <lsb_wrappers.h>
 #include "Utilities.h"
 #include "PlatformMidi.h"
 
diff --git openjdk-orig/jdk/src/solaris/native/java/lang/java_props_md.c openjdk/jdk/src/solaris/native/java/lang/java_props_md.c
index f3e4d60..42e3fec 100644
--- openjdk-orig/jdk/src/solaris/native/java/lang/java_props_md.c
+++ openjdk/jdk/src/solaris/native/java/lang/java_props_md.c
@@ -46,7 +46,9 @@
 #include "java_props.h"
 
 #ifdef __linux__
+#ifndef __LSB_VERSION__
 #define CODESET _NL_CTYPE_CODESET_NAME
+#endif
 #else
 #ifdef ALT_CODESET_KEY
 #define CODESET ALT_CODESET_KEY
diff --git openjdk-orig/jdk/src/solaris/native/java/net/Inet4AddressImpl.c openjdk/jdk/src/solaris/native/java/net/Inet4AddressImpl.c
index 7578dfa..886963d 100644
--- openjdk-orig/jdk/src/solaris/native/java/net/Inet4AddressImpl.c
+++ openjdk/jdk/src/solaris/native/java/net/Inet4AddressImpl.c
@@ -61,10 +61,10 @@ extern int gethostname(char *buf, int buf_len);
  */
 JNIEXPORT jstring JNICALL
 Java_java_net_Inet4AddressImpl_getLocalHostName(JNIEnv *env, jobject this) {
-    char hostname[MAXHOSTNAMELEN+1];
+    char hostname[NI_MAXHOST+1];
 
     hostname[0] = '\0';
-    if (JVM_GetHostName(hostname, MAXHOSTNAMELEN)) {
+    if (JVM_GetHostName(hostname, NI_MAXHOST)) {
         /* Something went wrong, maybe networking is not setup? */
         strcpy(hostname, "localhost");
     } else {
diff --git openjdk-orig/jdk/src/solaris/native/java/net/Inet6AddressImpl.c openjdk/jdk/src/solaris/native/java/net/Inet6AddressImpl.c
index 910d35b..66aad32 100644
--- openjdk-orig/jdk/src/solaris/native/java/net/Inet6AddressImpl.c
+++ openjdk/jdk/src/solaris/native/java/net/Inet6AddressImpl.c
@@ -31,6 +31,7 @@
 #include <string.h>
 #include <strings.h>
 #include <stdlib.h>
+#include <unistd.h>
 #include <ctype.h>
 
 #include "jvm.h"
@@ -40,6 +41,8 @@
 #include <netinet/icmp6.h>
 #endif
 
+#include <lsb_flags.h>
+
 #include "java_net_Inet4AddressImpl.h"
 #include "java_net_Inet6AddressImpl.h"
 
@@ -48,11 +51,6 @@
 #define NI_MAXHOST 1025
 #endif
 
-#ifndef __GLIBC__
-/* gethostname() is in libc.so but I can't find a header file for it */
-extern int gethostname(char *buf, int buf_len);
-#endif
-
 /************************************************************************
  * Inet6AddressImpl
  */
@@ -67,7 +65,7 @@ Java_java_net_Inet6AddressImpl_getLocalHostName(JNIEnv *env, jobject this) {
     char hostname[NI_MAXHOST+1];
 
     hostname[0] = '\0';
-    if (JVM_GetHostName(hostname, MAXHOSTNAMELEN)) {
+    if (JVM_GetHostName(hostname, NI_MAXHOST)) {
         /* Something went wrong, maybe networking is not setup? */
         strcpy(hostname, "localhost");
     } else {
@@ -483,6 +481,10 @@ ping6(JNIEnv *env, jint fd, struct sockaddr_in6* him, jint timeout,
      * For some strange reason, the linux kernel won't calculate the
      * checksum of ICMPv6 packets unless you set this socket option
      */
+    /** Note from LSB-OpenJDK project: that's violation of RFC3542 that
+     * was fixed in year 2008.  Now the setsockopt below will just
+     * return -1 and have no effect
+     */
     csum_offset = 2;
     setsockopt(fd, SOL_RAW, IPV6_CHECKSUM, &csum_offset, sizeof(int));
     }
diff --git openjdk-orig/jdk/src/solaris/native/java/net/NetworkInterface.c openjdk/jdk/src/solaris/native/java/net/NetworkInterface.c
index f60e03f..222ef91 100644
--- openjdk-orig/jdk/src/solaris/native/java/net/NetworkInterface.c
+++ openjdk/jdk/src/solaris/native/java/net/NetworkInterface.c
@@ -40,7 +40,6 @@
 #endif
 #ifdef __linux__
 #include <sys/ioctl.h>
-#include <bits/ioctls.h>
 #include <linux/sockios.h>
 #include <sys/utsname.h>
 #include <stdio.h>
@@ -53,6 +52,8 @@
 #define _PATH_PROCNET_IFINET6           "/proc/net/if_inet6"
 #endif
 
+#include <lsb_flags.h>
+
 #include "jvm.h"
 #include "jni_util.h"
 #include "net_util.h"
diff --git openjdk-orig/jdk/src/solaris/native/java/net/PlainDatagramSocketImpl.c openjdk/jdk/src/solaris/native/java/net/PlainDatagramSocketImpl.c
index c4032c8..07e96fb 100644
--- openjdk-orig/jdk/src/solaris/native/java/net/PlainDatagramSocketImpl.c
+++ openjdk/jdk/src/solaris/native/java/net/PlainDatagramSocketImpl.c
@@ -1568,6 +1568,15 @@ Java_java_net_PlainDatagramSocketImpl_socketSetOption(JNIEnv *env,
  *              Query NetworkInterface by index and
  *              return NetworkInterface.
  */
+/* Comment from LSB-openjdk project: getsockoft for IP_MULTICAST_IF returns,
+ * as defined by specifications of 4.0, struct in_addr.  setsockopt with 
+ * ADD/DROP_MEMBERSHIP takes struct mreq as parameter (as in LSB specs).
+ * So, we enwrap its usage into flags.
+ */
+#if (!defined __LSB_VERSION__) && (defined __linux__)
+#define DO_SUPPORT_MREQN
+#endif
+
 jobject getMulticastInterface(JNIEnv *env, jobject this, int fd, jint opt) {
     jboolean isIPV4 = JNI_TRUE;
 
@@ -1598,7 +1607,7 @@ jobject getMulticastInterface(JNIEnv *env, jobject this, int fd, jint opt) {
         struct in_addr *inP = &in;
         int len = sizeof(struct in_addr);
 
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
         struct ip_mreqn mreqn;
         if (isOldKernel) {
             inP = (struct in_addr *)&mreqn;
@@ -1629,7 +1638,7 @@ jobject getMulticastInterface(JNIEnv *env, jobject this, int fd, jint opt) {
         addr = (*env)->NewObject(env, inet4_class, inet4_ctrID, 0);
         CHECK_NULL_RETURN(addr, NULL);
 
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
         (*env)->SetIntField(env, addr, inet4_addrID,
                 (isOldKernel ? ntohl(mreqn.imr_address.s_addr) : ntohl(in.s_addr)) );
 #else
@@ -2130,7 +2139,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
      * On Linux if IPv4 or IPv6 use IP_ADD_MEMBERSHIP/IP_DROP_MEMBERSHIP
      */
     if (!ipv6_join_leave) {
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
         struct ip_mreqn mname;
 #else
         struct ip_mreq mname;
@@ -2148,7 +2157,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
          *              NetworkInterface
          */
         if (niObj != NULL) {
-#if defined(__linux__) && defined(AF_INET6)
+#if DO_SUPPORT_MREQN && defined(AF_INET6)
             if (ipv6_available()) {
                 static jfieldID ni_indexID;
 
@@ -2178,7 +2187,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
                 addr = (*env)->GetObjectArrayElement(env, addrArray, 0);
 
                 mname.imr_multiaddr.s_addr = htonl((*env)->GetIntField(env, iaObj, ia_addressID));
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
                 mname.imr_address.s_addr = htonl((*env)->GetIntField(env, addr, ia_addressID));
 #else
                 mname.imr_interface.s_addr = htonl((*env)->GetIntField(env, addr, ia_addressID));
@@ -2204,7 +2213,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
 
         if (niObj == NULL) {
 
-#if defined(__linux__) && defined(AF_INET6)
+#if DO_SUPPORT_MREQN && defined(AF_INET6)
             if (ipv6_available()) {
 
                 int index;
@@ -2231,7 +2240,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
                 struct in_addr *inP = &in;
                 int len = sizeof(struct in_addr);
 
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
                 struct ip_mreqn mreqn;
                 if (isOldKernel) {
                     inP = (struct in_addr *)&mreqn;
@@ -2243,7 +2252,7 @@ static void mcast_join_leave(JNIEnv *env, jobject this,
                     return;
                 }
 
-#ifdef __linux__
+#ifdef DO_SUPPORT_MREQN
                 mname.imr_address.s_addr =
                     (isOldKernel ? mreqn.imr_address.s_addr : in.s_addr);
 
diff --git openjdk-orig/jdk/src/solaris/native/java/net/linux_close.c openjdk/jdk/src/solaris/native/java/net/linux_close.c
index 0ac0acf..c72b9a8 100644
--- openjdk-orig/jdk/src/solaris/native/java/net/linux_close.c
+++ openjdk/jdk/src/solaris/native/java/net/linux_close.c
@@ -35,7 +35,7 @@
 #include <unistd.h>
 #include <errno.h>
 
-#include <sys/poll.h>
+#include <poll.h>
 
 /*
  * Stack allocated by thread when doing blocking operation
@@ -57,7 +57,7 @@ typedef struct {
 /*
  * Signal to unblock thread
  */
-static int sigWakeup = (__SIGRTMAX - 2);
+static int sigWakeup() {return (SIGRTMAX - 2); }
 
 /*
  * The fd table and the number of file descriptors
@@ -99,10 +99,10 @@ static void __attribute((constructor)) init() {
     sa.sa_handler = sig_wakeup;
     sa.sa_flags   = 0;
     sigemptyset(&sa.sa_mask);
-    sigaction(sigWakeup, &sa, NULL);
+    sigaction(sigWakeup(), &sa, NULL);
 
     sigemptyset(&sigset);
-    sigaddset(&sigset, sigWakeup);
+    sigaddset(&sigset, sigWakeup());
     sigprocmask(SIG_UNBLOCK, &sigset, NULL);
 }
 
@@ -198,7 +198,7 @@ static int closefd(int fd1, int fd2) {
         threadEntry_t *curr = fdEntry->threads;
         while (curr != NULL) {
             curr->intr = 1;
-            pthread_kill( curr->thr, sigWakeup );
+            pthread_kill( curr->thr, sigWakeup() );
             curr = curr->next;
         }
 
diff --git openjdk-orig/jdk/src/solaris/native/java/nio/MappedByteBuffer.c openjdk/jdk/src/solaris/native/java/nio/MappedByteBuffer.c
index 70c2d07..e6535e0 100644
--- openjdk-orig/jdk/src/solaris/native/java/nio/MappedByteBuffer.c
+++ openjdk/jdk/src/solaris/native/java/nio/MappedByteBuffer.c
@@ -32,6 +32,9 @@
 #include <stddef.h>
 #include <stdlib.h>
 
+//for mincore()
+#include <lsb_wrappers.h>
+
 
 JNIEXPORT jboolean JNICALL
 Java_java_nio_MappedByteBuffer_isLoaded0(JNIEnv *env, jobject obj,
@@ -50,6 +53,11 @@ Java_java_nio_MappedByteBuffer_isLoaded0(JNIEnv *env, jobject obj,
         return JNI_FALSE;
     }
 
+    // We can't guarantee that on LSB platform this functionality is supported
+    // Unless it is, we return false -- just like in code for Windows.
+    if (!mincore_available()){
+        return JNI_FALSE;
+    }
     result = mincore(a, (size_t)len, vec);
     if (result != 0) {
         free(vec);
@@ -77,7 +85,7 @@ Java_java_nio_MappedByteBuffer_load0(JNIEnv *env, jobject obj, jlong address,
     int *ptr = (int *)jlong_to_ptr(address);
     int i = 0;
     int j = 0;
-    int result = madvise((caddr_t)ptr, len, MADV_WILLNEED);
+    int result = posix_madvise((caddr_t)ptr, len, POSIX_MADV_WILLNEED);
 
     /* touch every page */
     for (i=0; i<numPages; i++) {
diff --git openjdk-orig/jdk/src/solaris/native/java/util/TimeZone_md.c openjdk/jdk/src/solaris/native/java/util/TimeZone_md.c
index a3b9fc7..2d3bfd7 100644
--- openjdk-orig/jdk/src/solaris/native/java/util/TimeZone_md.c
+++ openjdk/jdk/src/solaris/native/java/util/TimeZone_md.c
@@ -99,7 +99,7 @@ findZoneinfoFile(char *buf, size_t size, const char *dir)
     struct stat statbuf;
     union {
         struct dirent d;
-        char b[offsetof (struct dirent, d_name) + NAME_MAX + 1];
+        char b[offsetof (struct dirent, d_name) + sizeof( ((struct dirent*)(0))->d_name ) ];
     } entry;
     struct dirent *dp;
     char *pathname = NULL;
diff --git openjdk-orig/jdk/src/solaris/native/sun/awt/awt_xembed_server.c openjdk/jdk/src/solaris/native/sun/awt/awt_xembed_server.c
index 6dc5407..620a4a6 100644
--- openjdk-orig/jdk/src/solaris/native/sun/awt/awt_xembed_server.c
+++ openjdk/jdk/src/solaris/native/sun/awt/awt_xembed_server.c
@@ -835,6 +835,9 @@ Java_sun_awt_motif_GrabbedKey_initKeySymAndModifiers (JNIEnv *env, jobject this,
     AWT_UNLOCK();
 }
 
+// This function isn't used anyway, so we just mask it in order to
+// make appchecker not shout at usage of backtrace and backtrace_symbols.
+#ifndef __LSB_VERSION_
 #ifdef __linux__
 void
 print_stack (void)
@@ -855,6 +858,8 @@ print_stack (void)
   free (strings);
 }
 #endif
+#endif
+
 
 extern int32_t  numEventsHandled;
 
diff --git openjdk-orig/jdk/src/solaris/native/sun/nio/ch/EPollArrayWrapper.c openjdk/jdk/src/solaris/native/sun/nio/ch/EPollArrayWrapper.c
index 7b4a4e7..fe55061 100644
--- openjdk-orig/jdk/src/solaris/native/sun/nio/ch/EPollArrayWrapper.c
+++ openjdk/jdk/src/solaris/native/sun/nio/ch/EPollArrayWrapper.c
@@ -44,8 +44,8 @@ extern "C" {
 typedef union epoll_data {
     void *ptr;
     int fd;
-    __uint32_t u32;
-    __uint64_t u64;
+    uint32_t u32;
+    uint64_t u64;
 } epoll_data_t;
 
 
@@ -57,7 +57,7 @@ typedef union epoll_data {
 #endif
 
 struct epoll_event {
-    __uint32_t events;  /* Epoll events */
+    uint32_t events;  /* Epoll events */
     epoll_data_t data;  /* User data variable */
 } EPOLL_PACKED;
 
diff --git openjdk-orig/jdk/src/solaris/native/sun/nio/ch/NativeThread.c openjdk/jdk/src/solaris/native/sun/nio/ch/NativeThread.c
index ffd86d0..0e75ff2 100644
--- openjdk-orig/jdk/src/solaris/native/sun/nio/ch/NativeThread.c
+++ openjdk/jdk/src/solaris/native/sun/nio/ch/NativeThread.c
@@ -38,7 +38,7 @@
 #include <sys/signal.h>
 
 /* Also defined in src/solaris/native/java/net/linux_close.c */
-#define INTERRUPT_SIGNAL (__SIGRTMAX - 2)
+static int INTERRUPT_SIGNAL() {return (SIGRTMAX - 2);}
 
 static void
 nullHandler(int sig)
@@ -65,7 +65,7 @@ Java_sun_nio_ch_NativeThread_init(JNIEnv *env, jclass cl)
     sa.sa_handler = nullHandler;
     sa.sa_flags = 0;
     sigemptyset(&sa.sa_mask);
-    if (sigaction(INTERRUPT_SIGNAL, &sa, &osa) < 0)
+    if (sigaction(INTERRUPT_SIGNAL(), &sa, &osa) < 0)
         JNU_ThrowIOExceptionWithLastError(env, "sigaction");
 
 #endif
@@ -85,7 +85,7 @@ JNIEXPORT void JNICALL
 Java_sun_nio_ch_NativeThread_signal(JNIEnv *env, jclass cl, jlong thread)
 {
 #ifdef __linux__
-    if (pthread_kill((pthread_t)thread, INTERRUPT_SIGNAL))
+    if (pthread_kill((pthread_t)thread, INTERRUPT_SIGNAL()))
         JNU_ThrowIOExceptionWithLastError(env, "Thread signal failed");
 #endif
 }
diff --git openjdk-orig/jdk/src/solaris/native/sun/security/pkcs11/j2secmod_md.c openjdk/jdk/src/solaris/native/sun/security/pkcs11/j2secmod_md.c
index f92d263..94d21ef 100644
--- openjdk-orig/jdk/src/solaris/native/sun/security/pkcs11/j2secmod_md.c
+++ openjdk/jdk/src/solaris/native/sun/security/pkcs11/j2secmod_md.c
@@ -34,6 +34,9 @@
 
 #include "j2secmod.h"
 
+//for RTLD_NOLOAD
+#include <lsb_flags.h>
+
 void *findFunction(JNIEnv *env, jlong jHandle, const char *functionName) {
     void *hModule = (void*)jHandle;
     void *fAddress = dlsym(hModule, functionName);
diff --git openjdk-orig/jdk/src/solaris/native/sun/tools/attach/LinuxVirtualMachine.c openjdk/jdk/src/solaris/native/sun/tools/attach/LinuxVirtualMachine.c
index 49f5819..cdceab7 100644
--- openjdk-orig/jdk/src/solaris/native/sun/tools/attach/LinuxVirtualMachine.c
+++ openjdk/jdk/src/solaris/native/sun/tools/attach/LinuxVirtualMachine.c
@@ -65,7 +65,35 @@ static void forEachProcess(ProcessCallback f, void* user_data) {
      * position integer as a filename.
      */
     if ((dir = opendir("/proc")) == NULL) {
+#ifndef __LSB_VERSION__
         return;
+#else
+        /* Notes from LSB-OpenJDK project
+         * We don't give up!  LSB says that `ps -A` should work.
+         * Yes, ps -A also does the same thing.  This may seem dumb, but I
+         * guess, I have to do it.
+         */
+        char buf[100] = "ps -A";
+        FILE * pipe;
+        /* simply invoke a app, pipe output*/
+        pipe = popen(buf, "r" );
+        if (pipe == NULL ) {
+            fprintf(stderr,"invoking %s failed: %s\n", buf, strerror(errno));
+            return;
+        }
+
+        while(!feof(pipe) ) {
+            if( fgets( buf, 100, pipe ) != NULL ) {
+                int pid;
+                if (sscanf(buf,"%d",&pid) != 1 || pid <= 0) continue;
+                (*f)(pid, user_data);
+            }
+        }
+
+        /* Close pipe */
+        pclose(pipe);
+        return;
+#endif
     }
     while ((ptr = readdir(dir)) != NULL) {
         pid_t pid;
